/*
 * sqmgrlog - Squid user management log
 * Mar/98 - Pedro L Orso - orso@onda.com.br
 */

#include "conf.h"
#include "extern.h"

void report_day(const char *dirname, char *user, int *iprel, int *ipuser, char *BgColor, char *TxColor, char *TxBgColor, char *TiColor, char *LogoImage, char *LogoText, char *LogoTextColor, char *Width, char *Height, char *Title, char *BgImage, char *FontFace, char *HeaderColor, char *HeaderBgColor, char *FontSize, char *TempDir, char *UserSortField, char *UserSortOrder, char *DateFormat, char *periodo)

{

   FILE *fp_in, *fp_ou;
      
   char data[15];
   char dia[3];
   char mes[3];
   char ano[3];
   char odata[15];
   char hora[15];
   char elap[15];
   char oelap[15];
   char whora[3];
   char html[8000];
   char arqout[MAXLEN];
   char wdirname[MAXLEN];
   char wuser[255];
   char c00[12];
   char c01[12];
   char c02[12];
   char c03[12];
   char c04[12];
   char c05[12];
   char c06[12];
   char c07[12];
   char c08[12];
   char c09[12];
   char c10[12];
   char c11[12];
   char c12[12];
   char c13[12];
   char c14[12];
   char c15[12];
   char c16[12];
   char c17[12];
   char c18[12];
   char c19[12];
   char c20[12];
   char c21[12];
   char c22[12];
   char c23[12];
   int  count=0;
   int  ihora=0;
   long int telap=0;
   long int v00=0;
   long int v01=0;
   long int v02=0;
   long int v03=0;
   long int v04=0;
   long int v05=0;
   long int v06=0;
   long int v07=0;
   long int v08=0;
   long int v09=0;
   long int v10=0;
   long int v11=0;
   long int v12=0;
   long int v13=0;
   long int v14=0;
   long int v15=0;
   long int v16=0;
   long int v17=0;
   long int v18=0;
   long int v19=0;
   long int v20=0;
   long int v21=0;
   long int v22=0;
   long int v23=0;
   long int tt=0;
   long int gtt=0;
   long int t00=0;
   long int t01=0;
   long int t02=0;
   long int t03=0;
   long int t04=0;
   long int t05=0;
   long int t06=0;
   long int t07=0;
   long int t08=0;
   long int t09=0;
   long int t10=0;
   long int t11=0;
   long int t12=0;
   long int t13=0;
   long int t14=0;
   long int t15=0;
   long int t16=0;
   long int t17=0;
   long int t18=0;
   long int t19=0;
   long int t20=0;
   long int t21=0;
   long int t22=0;
   long int t23=0;
   char ftime[128];

   sprintf(wdirname,"%s/%s.day",dirname,user);
   sprintf(arqout,"%s/d%s.html",dirname,user);

   if((fp_in=fopen(wdirname,"r"))==NULL) {
     fprintf(stderr, "SQMGRLOG: (totday) %s: %s\n",msg05,wdirname);
     exit(1);
   }

   if((fp_ou=fopen(arqout,"w"))==NULL) {
     fprintf(stderr, "SQMGRLOG: (totday) %s: %s\n",msg05,arqout);
     exit(1);
   }

   fputs("<html>\n",fp_ou);

   if(strlen(FontFace) > 0) {
      sprintf(html,"<font face=%s>\n",FontFace);
      fputs(html,fp_ou);
   }

   sprintf(html,"<body bgcolor=%s text=%s background='%s'>\n",BgColor,TxColor,BgImage);
   fputs(html,fp_ou);

   fputs("<center><table cellpadding=0 cellspacing=0>\n",fp_ou);

   if(strlen(LogoImage) > 0) {
      sprintf(html,"<tr><th align=left><img src='%s' border=0 align=absmiddle width=%s height=%s><font color=%s>%s</font>\n",LogoImage,Width,Height,LogoTextColor,LogoText); 
      fputs(html,fp_ou);
   }

   sprintf(html,"<tr><th align=center colspan=2><b><font color=%s size=+1>%s</font></b></th></tr>\n",TiColor,Title);
   fputs(html,fp_ou);
   
   fputs("</table></center>\n",fp_ou);
   fputs("<center><table cellpadding=0 cellspacing=0>\n",fp_ou);

   sprintf(html,"<tr><td align=right bgcolor=%s><font size=%s>%s:</font><td align=left bgcolor=%s><font size=%s>%s</font></td></td></tr>\n",HeaderBgColor,FontSize,htm02,TxBgColor,FontSize,periodo);
   fputs(html,fp_ou);

   strcpy(wuser,user);
   if(strstr(wuser,"_") != 0)
      fixip(wuser);
     
   sprintf(html,"<tr><td align=right bgcolor=%s><font size=%s>%s:</font><td align=left bgcolor=%s><font size=%s>%s</font></td></td></tr>\n",HeaderBgColor,FontSize,htm03,TxBgColor,FontSize,wuser);
   fputs(html,fp_ou);

   fputs("<tr><td></td></tr><tr><td></td></tr>\n",fp_ou);
   fputs("<tr><td></td></tr><tr><td></td></tr></table>\n",fp_ou);

   fputs("<table border=1 cellpadding=2 cellspacing=0>\n", fp_ou);

   sprintf(html,"<tr><td border=0></td><td align=center bgcolor=%s><font size=-2>06<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>07<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>08<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>09<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>10<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>11<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>12<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>13<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>14<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>15<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>16<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>17<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>18<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>19<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>20<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>21<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>22<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>23<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>00<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>01<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>02<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>03<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>04<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>05<br>H:M:S</td><td align=center bgcolor=%s><font size=-2>%s<br>H:M:S</td></tr>\n",HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,HeaderBgColor,htm20);
   fputs(html,fp_ou);

   while(fgets(buf,sizeof(buf),fp_in)!=NULL) {
      getword(data,buf,' ');
      if(!count) {
         strcpy(odata,data);
         count++;
      }
      getword(hora,buf,' ');
      getword(elap,buf,' ');
      elap[strlen(elap)-1]='\0';

      if(strcmp(data,odata) != 0) {
         strcpy(oelap,elap);
         sprintf(c00,"%s",fixtime(v00));
         sprintf(c01,"%s",fixtime(v01));
         sprintf(c02,"%s",fixtime(v02));
         sprintf(c03,"%s",fixtime(v03));
         sprintf(c04,"%s",fixtime(v04));
         sprintf(c05,"%s",fixtime(v05));
         sprintf(c06,"%s",fixtime(v06));
         sprintf(c07,"%s",fixtime(v07));
         sprintf(c08,"%s",fixtime(v08));
         sprintf(c09,"%s",fixtime(v09));
         sprintf(c10,"%s",fixtime(v10));
         sprintf(c11,"%s",fixtime(v11));
         sprintf(c12,"%s",fixtime(v12));
         sprintf(c13,"%s",fixtime(v13));
         sprintf(c14,"%s",fixtime(v14));
         sprintf(c15,"%s",fixtime(v15));
         sprintf(c16,"%s",fixtime(v16));
         sprintf(c17,"%s",fixtime(v17));
         sprintf(c18,"%s",fixtime(v18));
         sprintf(c19,"%s",fixtime(v19));
         sprintf(c20,"%s",fixtime(v20));
         sprintf(c21,"%s",fixtime(v21));
         sprintf(c22,"%s",fixtime(v22));
         sprintf(c23,"%s",fixtime(v23));

         sprintf(html,"<tr><td align=center bgcolor=%s><font color=darkblue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=darkblue size=-2>%s</td></tr>\n",HeaderBgColor,odata,TxBgColor,c06,TxBgColor,c07,TxBgColor,c08,TxBgColor,c09,TxBgColor,c10,TxBgColor,c11,TxBgColor,c12,TxBgColor,c13,TxBgColor,c14,TxBgColor,c15,TxBgColor,c16,TxBgColor,c17,TxBgColor,c18,TxBgColor,c19,TxBgColor,c20,TxBgColor,c21,TxBgColor,c22,TxBgColor,c23,TxBgColor,c00,TxBgColor,c01,TxBgColor,c02,TxBgColor,c03,TxBgColor,c04,TxBgColor,c05,HeaderBgColor,fixtime(tt));
         fputs(html, fp_ou);
        
         tt=0;
         v00=0;
         v01=0;
         v02=0;
         v03=0;
         v04=0;
         v05=0;
         v06=0;
         v07=0;
         v08=0;
         v09=0;
         v10=0;
         v11=0;
         v12=0;
         v13=0;
         v14=0;
         v15=0;
         v16=0;
         v17=0;
         v18=0;
         v19=0;
         v20=0;
         v21=0;
         v22=0;
         v23=0;
         strcpy(odata,data);
         strcpy(elap,oelap);
      }

      ihora=atoi(hora);

      switch(ihora) {
         case 0:
            v00+=atol(elap);
            t00+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 1:
            v01+=atol(elap);
            t01+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 2:
            v02+=atol(elap);
            t02+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 3:
            v03+=atol(elap);
            t03+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 4:
            v04+=atol(elap);
            t04+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 5:
            v05+=atol(elap);
            t05+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 6:
            v06+=atol(elap);
            t06+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 7:
            v07+=atol(elap);
            t07+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 8:
            v08+=atol(elap);
            t08+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 9:
            v09+=atol(elap);
            t09+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 10:
            v10+=atol(elap);
            t10+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 11:
            v11+=atol(elap);
            t11+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 12:
            v12+=atol(elap);
            t12+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 13:
            v13+=atol(elap);
            t13+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 14:
            v14+=atol(elap);
            t14+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 15:
            v15+=atol(elap);
            t15+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 16:
            v16+=atol(elap);
            t16+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 17:
            v17+=atol(elap);
            t17+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 18:
            v18+=atol(elap);
            t18+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 19:
            v19+=atol(elap);
            t19+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 20:
            v20+=atol(elap);
            t20+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 21:
            v21+=atol(elap);
            t21+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 22:
            v22+=atol(elap);
            t22+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
         case 23:
            v23+=atol(elap);
            t23+=atol(elap);
            tt+=atol(elap);
            gtt+=atol(elap);
            break;
      }
   }

   sprintf(c00,"%s",fixtime(v00));
   sprintf(c01,"%s",fixtime(v01));
   sprintf(c02,"%s",fixtime(v02));
   sprintf(c03,"%s",fixtime(v03));
   sprintf(c04,"%s",fixtime(v04));
   sprintf(c05,"%s",fixtime(v05));
   sprintf(c06,"%s",fixtime(v06));
   sprintf(c07,"%s",fixtime(v07));
   sprintf(c08,"%s",fixtime(v08));
   sprintf(c09,"%s",fixtime(v09));
   sprintf(c10,"%s",fixtime(v10));
   sprintf(c11,"%s",fixtime(v11));
   sprintf(c12,"%s",fixtime(v12));
   sprintf(c13,"%s",fixtime(v13));
   sprintf(c14,"%s",fixtime(v14));
   sprintf(c15,"%s",fixtime(v15));
   sprintf(c16,"%s",fixtime(v16));
   sprintf(c17,"%s",fixtime(v17));
   sprintf(c18,"%s",fixtime(v18));
   sprintf(c19,"%s",fixtime(v19));
   sprintf(c20,"%s",fixtime(v20));
   sprintf(c21,"%s",fixtime(v21));
   sprintf(c22,"%s",fixtime(v22));
   sprintf(c23,"%s",fixtime(v23));
   sprintf(html,"<tr><td align=center bgcolor=%s><font color=darkblue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=blue size=-2>%s</td><td align=center bgcolor=%s><font color=darkblue size=-2>%s</td></tr>\n",HeaderBgColor,data,TxBgColor,c06,TxBgColor,c07,TxBgColor,c08,TxBgColor,c09,TxBgColor,c10,TxBgColor,c11,TxBgColor,c12,TxBgColor,c13,TxBgColor,c14,TxBgColor,c15,TxBgColor,c16,TxBgColor,c17,TxBgColor,c18,TxBgColor,c19,TxBgColor,c20,TxBgColor,c21,TxBgColor,c22,TxBgColor,c23,TxBgColor,c00,TxBgColor,c01,TxBgColor,c02,TxBgColor,c03,TxBgColor,c04,TxBgColor,c05,HeaderBgColor,fixtime(tt));
   fputs(html, fp_ou);

   sprintf(c00,"%s",fixtime(t00));
   sprintf(c01,"%s",fixtime(t01));
   sprintf(c02,"%s",fixtime(t02));
   sprintf(c03,"%s",fixtime(t03));
   sprintf(c04,"%s",fixtime(t04));
   sprintf(c05,"%s",fixtime(t05));
   sprintf(c06,"%s",fixtime(t06));
   sprintf(c07,"%s",fixtime(t07));
   sprintf(c08,"%s",fixtime(t08));
   sprintf(c09,"%s",fixtime(t09));
   sprintf(c10,"%s",fixtime(t10));
   sprintf(c11,"%s",fixtime(t11));
   sprintf(c12,"%s",fixtime(t12));
   sprintf(c13,"%s",fixtime(t13));
   sprintf(c14,"%s",fixtime(t14));
   sprintf(c15,"%s",fixtime(t15));
   sprintf(c16,"%s",fixtime(t16));
   sprintf(c17,"%s",fixtime(t17));
   sprintf(c18,"%s",fixtime(t18));
   sprintf(c19,"%s",fixtime(t19));
   sprintf(c20,"%s",fixtime(t20));
   sprintf(c21,"%s",fixtime(t21));
   sprintf(c22,"%s",fixtime(t22));
   sprintf(c23,"%s",fixtime(t23));

   sprintf(html,"<tr><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td><td align=center bgcolor=%s><font color=%s size=-2>%s</td></tr>\n",
HeaderBgColor,HeaderColor,htm20,HeaderBgColor,HeaderColor,c06,HeaderBgColor,HeaderColor,c07,HeaderBgColor,HeaderColor,c08,HeaderBgColor,HeaderColor,c09,HeaderBgColor,HeaderColor,c10,HeaderBgColor,HeaderColor,c11,HeaderBgColor,HeaderColor,c12,HeaderBgColor,HeaderColor,c13,HeaderBgColor,HeaderColor,c14,HeaderBgColor,HeaderColor,c15,HeaderBgColor,HeaderColor,c16,HeaderBgColor,HeaderColor,c17,HeaderBgColor,HeaderColor,c18,HeaderBgColor,HeaderColor,c19,HeaderBgColor,HeaderColor,c20,HeaderBgColor,HeaderColor,c21,HeaderBgColor,HeaderColor,c22,HeaderBgColor,HeaderColor,c23,HeaderBgColor,HeaderColor,c00,HeaderBgColor,HeaderColor,c01,HeaderBgColor,HeaderColor,c02,HeaderBgColor,HeaderColor,c03,HeaderBgColor,HeaderColor,c04,HeaderBgColor,HeaderColor,c05,HeaderBgColor,HeaderColor,fixtime(gtt));

   fputs(html, fp_ou);
   fputs("</table>\n", fp_ou);

   zdate(ftime, DateFormat);
   sprintf(html,"<br><br><center><font size=-2>%s <a href='%s'>%s-%s</a> %s %s</font></center>\n",htm21,URL,PGM,VERSION,htm22,ftime);
   fputs(html, fp_ou);

   fclose(fp_in);
   fclose(fp_ou);

//   unlink(wdirname);

   return;
}
