/*
 * sqmgrlog - Squid user management log
 * Mar/98 - Pedro L Orso - orso@onda.com.br
 */

#include "conf.h"
#include "extern.h"

int gerarel(char *tmp, int *debug, const char *periodo, int *debugz, int *iprel, char* outdir, char *addr, char *site, char *us, int *userip, char *email, char *temp2, char *BgColor, char *TxColor, char *TxBgColor, char *TiColor, char *LogoImage, char *LogoText, char *LogoTextColor, char *Width, char *Height, char *Title, char *BgImage, char *FontFace, char *HeaderColor, char *HeaderBgColor, char *FontSize, char *TempDir, char *Ip2Name, char *TopuserSortField, char *UserSortField, char *TopuserSortOrder, char *UserSortOrder, char *UserAgentLog, char *DateFormat, int *indexonly, char *PerUserLimitFile, char *PerUserLimit)
{

   FILE *fp_in, *fp_ou;

   time_t tt;
   char accdia[9], acchora[9], accuser[MAXLEN], accip[MAXLEN], accurl[MAXLEN], acctam[12], accelap[10];
   char oldaccdia[9], oldacchora[9], oldaccip[MAXLEN], wdir[MAXLEN], per1[MAXLEN];
   char dirname[MAXLEN], wdirname[MAXLEN], accnome[50], oldurl[MAXLEN], oldaccuser[MAXLEN], struser[MAXLEN];
   char olduser[MAXLEN], oldmsg[50], acccode[50], oldaccelap[10], oldacccode[50];
   char ipantes[MAXLEN], nameantes[MAXLEN]; 
   char accsmart[MAXLEN];
   int  smartfilter=0;
   char wcrc[50];
   char crc2[50];
   char *userfile;
   unsigned long nbytes=0; 
   unsigned long nelap=0; 
   unsigned long nacc=0;
   unsigned long rtotal=0;
   unsigned long incache=0;
   unsigned long oucache=0;

   ipantes[0]='\0';
   nameantes[0]='\0';

   sprintf(dirname, "%s%s", outdir, periodo);
   sprintf(wdir, "%s%s", outdir, periodo);
   strcpy(per1,periodo);
   vrfydir(wdir, dirname, per1, addr, site, us, debug, email, temp2);

   if(debugz){
      debugaz("dirname",dirname);
      debugaz("wdir",wdir);
   }
 
   strcpy(wdirname,dirname);
   gperiodo(wdirname, periodo, debug);

   if(strlen(UserAgentLog) > 0 && email[0] == '\0') {
      strcpy(wdirname,dirname);
      useragent(wdirname,debug,outdir,TempDir,UserAgentLog,periodo,BgColor,TxColor,TxBgColor,TiColor,LogoImage,LogoText,LogoTextColor,Width,Height,Title,BgImage,FontFace,HeaderColor,HeaderBgColor,FontSize,Ip2Name, DateFormat);
   }

   olduser[0]='\0';

   if((fp_in=fopen(tmp,"r"))==NULL){
      fprintf(stderr, "SQMGRLOG: (report) %s: %s\n",msg42,tmp);
      exit(1);}

   while(fgets(buf,sizeof(buf),fp_in)!=NULL) {
      getword(accdia,buf,' ');
      getword(acchora,buf,' ');
      getword(accuser,buf,' ');
      getword(accip,buf,' ');
      getword(accurl,buf,' ');
      getword(acctam,buf,' ');
      getword(acccode,buf,' ');
      getword(accelap,buf,' ');
      getword(accsmart,buf,' ');
      getword(accsmart,buf,'"');

      if(strlen(accsmart) > 0) {
         smartfilter++;
         strcpy(wdirname,dirname);
         grava_SmartFilter(wdirname,accuser,accip,accdia,acchora,accurl,accsmart);
      }

      if(strcmp(Ip2Name,"yes") == 0) {
         if(strcmp(accip,ipantes) != 0) {
            strcpy(ipantes,accip);
            ip2name(accip);
            strcpy(nameantes,accip);
         } else strcpy(accip,nameantes);
      }
     
      if(strcmp(olduser,accuser) != 0){
         strcpy(wdirname,dirname);
	 criatmp(accuser,wdirname,debug,indexonly);
	 criatmp_hora(accuser,wdirname,indexonly);
         strcpy(olduser,accuser);
      }

      strcpy(wdirname,dirname);
      gravatmp_hora(wdirname,accuser,accdia,acchora,accelap,indexonly);

      if(iprel){
         strcpy(wdirname,dirname);
         gravaporuser(accuser,wdirname,accurl,accip,accdia,acchora,acctam,accelap,indexonly);
      }

      if(!rtotal){
         strcpy(oldurl,accurl);
         strcpy(oldacccode,acccode);
         strcpy(oldaccelap,accelap);
         strcpy(oldaccuser,accuser);
         strcpy(oldaccip,accip);
         strcpy(oldaccdia,accdia);
         strcpy(oldacchora,acchora);
         rtotal++;
      }
        
      if(site[0] != '\0') {
         if(strcmp(oldaccuser,accuser) != 0 || strcmp(oldaccuser,accuser) != 0){
            strcpy(oldmsg,"OK");
            if(strstr(oldacccode,"DENIED") != 0)
               sprintf(oldmsg,"%s",msg43);
            strcpy(wdirname,dirname);
            gravatmp(oldaccuser,wdirname,oldurl,nacc,nbytes,oldmsg,nelap,indexonly,incache,oucache);
            strcpy(wdirname,dirname);
            gravager(wdirname,oldaccuser,nacc,oldurl,nbytes,oldaccip,oldacchora,oldaccdia,nelap,incache,oucache);
            nacc=0;
            nbytes=0;
            nelap=0;
            incache=0;
            oucache=0;
         }
      } else {     
         if(strcmp(oldurl,accurl) != 0 || strcmp(oldaccuser,accuser) != 0){
            strcpy(oldmsg,"OK");
            if(strstr(oldacccode,"DENIED") != 0)
               sprintf(oldmsg,"%s",msg43);
            strcpy(wdirname,dirname);
            gravatmp(oldaccuser,wdirname,oldurl,nacc,nbytes,oldmsg,nelap,indexonly,incache,oucache);
            strcpy(wdirname,dirname);
            gravager(wdirname,oldaccuser,nacc,oldurl,nbytes,oldaccip,oldacchora,oldaccdia,nelap,incache,oucache);
            nacc=0;
            nbytes=0;
            nelap=0;
            incache=0;
            oucache=0;
         }
      }
      nacc++;
      nbytes=nbytes+atol(acctam);
      nelap=nelap+atol(accelap);

      strcpy(wcrc,acccode);
      getword(crc2,wcrc,'/');

      if(strstr(crc2,"MISS") != 0)
         oucache+=atol(acctam);
       else incache+=atol(acctam);

      strcpy(oldurl,accurl);

      if(strcmp(accuser,oldaccuser) != 0) {
         strcpy(wdirname,dirname);
         totaliza_day(wdirname,oldaccuser,indexonly);
      }

      strcpy(oldaccuser,accuser);
      strcpy(oldacccode,acccode);
      strcpy(oldaccelap,accelap);
      strcpy(oldaccip,accip);
      strcpy(oldaccdia,accdia);
      strcpy(oldacchora,acchora);

   }

   strcpy(oldmsg,"OK");
   if(strstr(oldacccode,"DENIED") != 0)
      sprintf(oldmsg,"%s",msg43);
   strcpy(wdirname,dirname);
   gravatmpf(oldaccuser,wdirname,oldurl,nacc,nbytes,oldmsg,nelap,indexonly,incache,oucache);
   strcpy(wdirname,dirname);
   gravager(wdirname,oldaccuser,nacc,oldurl,nbytes,oldaccip,oldacchora,oldaccdia,nelap,incache,oucache);
   strcpy(wdirname,dirname);
   totaliza_day(wdirname,oldaccuser,indexonly);
 
   fclose(fp_in);

   strcpy(wdirname,dirname);
   tmpsort(wdirname, debug, TempDir, TopuserSortField, UserSortField, TopuserSortOrder, UserSortOrder, indexonly);

   strcpy(wdirname,dirname);
   totalger(wdirname, debug, outdir, BgColor, TxColor, TxBgColor, TiColor, LogoImage, LogoText, LogoTextColor, Width, Height, Title, BgImage, FontFace, HeaderColor, HeaderBgColor, FontSize, TempDir);

   if(strlen(email) == 0) {
      strcpy(wdirname,dirname);
      topuser(wdirname, debug, outdir, userip, BgColor, TxColor, TxBgColor, TiColor, LogoImage, LogoText, LogoTextColor, Width, Height, Title, BgImage, FontFace, HeaderColor, HeaderBgColor, FontSize, TempDir, Ip2Name, TopuserSortField, TopuserSortOrder, UserAgentLog, DateFormat, smartfilter);

      strcpy(wdirname,dirname);
      topsites(wdirname, debug, outdir, userip, BgColor, TxColor, TxBgColor, TiColor, LogoImage, LogoText, LogoTextColor, Width, Height, Title, BgImage, FontFace, HeaderColor, HeaderBgColor, FontSize, TempDir, Ip2Name, TopuserSortField, TopuserSortOrder, UserAgentLog, DateFormat);

      strcpy(wdirname,dirname);
      siteuser(wdirname, debug, outdir, userip, BgColor, TxColor, TxBgColor, TiColor, LogoImage, LogoText, LogoTextColor, Width, Height, Title, BgImage, FontFace, HeaderColor, HeaderBgColor, FontSize, TempDir, Ip2Name, TopuserSortField, TopuserSortOrder, UserAgentLog, DateFormat);

      if(smartfilter) {
         strcpy(wdirname,dirname);
         smartfilter_report(wdirname, debug, outdir, userip, BgColor, TxColor, TxBgColor, TiColor, LogoImage, LogoText, LogoTextColor, Width, Height, Title, BgImage, FontFace, HeaderColor, HeaderBgColor, FontSize, TempDir, Ip2Name, TopuserSortField, TopuserSortOrder, UserAgentLog, DateFormat);
      }

      strcpy(wdirname,dirname);
      htmlrel(wdirname, debug, iprel, userip, BgColor, TxColor, TxBgColor, TiColor, LogoImage, LogoText, LogoTextColor, Width, Height, Title, BgImage, FontFace, HeaderColor, HeaderBgColor, FontSize, TempDir, UserSortField, UserSortOrder, DateFormat, indexonly, PerUserLimitFile, PerUserLimit, Ip2Name);

      strcpy(wdirname,outdir);
      geraindex(wdirname, debug, BgColor, TxColor, TxBgColor, TiColor, LogoImage, LogoText, LogoTextColor, Width, Height, Title, BgImage, FontFace, HeaderColor, HeaderBgColor, FontSize, TempDir, DateFormat, periodo);

      fprintf(stderr, "SQMGRLOG: %s %s\n",msg44,dirname);
    } else {
      strcpy(wdirname,dirname);
      geramail(wdirname, debug, outdir, userip, email, TempDir);

      if(strcmp(email,"stdout") != 0)
         fprintf(stderr, "SQMGRLOG: %s %s\n",msg45,email);
   }

   if(indexonly) {
      strcpy(wdirname,dirname);
      index_only(wdirname, debug);
   }

   removetmp(dirname,debug);

   return;
}


int criatmp(char *user, char *dirname, int debug, int indexonly)
{

   FILE *fp_ou;

   char wdirname[MAXLEN];

   if(indexonly)
      return;

   strcpy(wdirname,dirname);
   strcat(wdirname,"/");
   strcat(wdirname,user);

   if(debug){
      sprintf(msg,"%s: %s",msg46,wdirname);
      debuga(msg);
   }

   strcat(wdirname,".tmp");
   if((fp_ou=fopen(wdirname,"w"))==NULL){
      fprintf(stderr, "SQMGRLOG: (report) %s: %s\n",msg42,wdirname);
      exit(1);
   }

   fclose(fp_ou);
   return;
}


int criatmp_hora(char *user, char *dirname, int indexonly)
{

   FILE *fp_ou;

   char wdirname[MAXLEN];

   if(indexonly)
      return;

   strcpy(wdirname,dirname);
   strcat(wdirname,"/");
   strcat(wdirname,user);

   strcat(wdirname,".htmp");
   if((fp_ou=fopen(wdirname,"w"))==NULL){
      fprintf(stderr, "SQMGRLOG: (report) %s: %s\n",msg42,wdirname);
      exit(1);
   }

   fclose(fp_ou);
   return;
}


int gravatmp(char *oldaccuser, char *dirname, char *oldurl, unsigned long nacc, unsigned long nbytes, char *oldmsg, unsigned long nelap, int indexonly, unsigned long incache, unsigned long oucache)
{

   FILE *fp_ou;

   char reg[MAXLEN];
   char wdirname[MAXLEN];

   if(indexonly)
      return;

   strcpy(wdirname,dirname);
   strcat(wdirname,"/");
   strcat(wdirname,oldaccuser);
   strcat(wdirname,".tmp");

   if((fp_ou=fopen(wdirname,"a"))==NULL){
      fprintf(stderr, "SQMGRLOG: (report) %s: %s\n",msg42,wdirname);
      exit(1);
   } 

   sprintf(reg,"%010d %010d %s %s %010d %010d %010d\n",nacc,nbytes,oldurl,oldmsg,nelap,incache,oucache);
   fputs(reg,fp_ou);

   fclose(fp_ou);

   return(0);

}


int gravatmp_hora(char *dirname, char *user, char *data, char *hora, char *elap, int indexonly)
{

   FILE *fp_ou;

   char reg[MAXLEN];
   char wdirname[MAXLEN];

   if(indexonly)
      return;

   strcpy(wdirname,dirname);
   strcat(wdirname,"/");
   strcat(wdirname,user);
   strcat(wdirname,".htmp");

   if((fp_ou=fopen(wdirname,"a"))==NULL){
      fprintf(stderr, "SQMGRLOG: (report) %s: %s\n",msg42,wdirname);
      exit(1);
   }

   sprintf(reg,"%s %s %s\n",data,hora,elap);
   fputs(reg,fp_ou);

   fclose(fp_ou);

   return(0);
}


int gravaporuser(char *user, char *dirname, char *url, char *ip, char *data, char *hora, char *tam, char *elap, int indexonly)
{

   FILE *fp_ou;

   char reg[MAXLEN];
   char wdirname[MAXLEN];

   if(indexonly)
      return;

   strcpy(wdirname,dirname);
   strcat(wdirname,"/");
   strcat(wdirname,user);
   strcat(wdirname,".ip");

   if((fp_ou=fopen(wdirname,"a"))==NULL){
      fprintf(stderr, "SQMGRLOG: (report) %s: %s\n",msg42,wdirname);
      exit(1);
   } 

   sprintf(reg,"%s %s %s %s %s %s\n",ip,url,data,hora,tam,elap);
   fputs(reg,fp_ou);

   fclose(fp_ou);

   return(0);

}


int gravatmpf(char *oldaccuser, char *dirname, char *oldurl, unsigned long nacc, unsigned long nbytes, char *oldmsg, unsigned long nelap, int indexonly, unsigned long incache, unsigned long oucache)
{

   FILE *fp_ou;

   char reg[MAXLEN];
   char wdirname[MAXLEN];

   if(indexonly)
      return;

   strcpy(wdirname,dirname);
   strcat(wdirname,"/");
   strcat(wdirname,oldaccuser);
   strcat(wdirname,".tmp");

   if((fp_ou=fopen(wdirname,"a"))==NULL){
      fprintf(stderr, "SQMGRLOG: (report) %s: %s\n",msg42,wdirname);
      exit(1);
   }

   sprintf(reg,"%010d %010d %s %s %010d %010d %010d\n",nacc,nbytes,oldurl,oldmsg,nelap,incache,oucache);
   fputs(reg,fp_ou);

   fclose(fp_ou);
   return;
     
}


int gravager(char *dirname, char *user, unsigned long *nacc, char *url, unsigned long *nbytes, char *ip, char *hora, char *dia, unsigned long *nelap, unsigned long incache, unsigned long oucache)
{

   FILE *fp_ou;
   char reg[MAXLEN];

   strcat(dirname,"/");
   strcat(dirname,"geral");
   
   if((fp_ou=fopen(dirname,"a"))==NULL){
      fprintf(stderr, "SQMGRLOG: (report) %s: %s\n",msg42,dirname);
      exit(1);
   }

   sprintf(reg,"%s %010d %010d %s %s %s %s %010d %010d %010d\n",user,nacc,nbytes,url,ip,hora,dia,nelap,incache,oucache);
   fputs(reg,fp_ou);

   fclose(fp_ou);
   return;

}

int grava_SmartFilter(char *dirname, char *user, char *ip, char *data, char *hora, char *url, char *smart)
{

   FILE *fp_ou;

   char reg[MAXLEN];
   char wdirname[MAXLEN];
   char *str;

   sprintf(wdirname,"%s/smartfilter.unsort",dirname);

   if((fp_ou=fopen(wdirname,"a"))==NULL){
      fprintf(stderr, "SQMGRLOG: (report) %s: %s\n",msg42,wdirname);
      exit(1);
   }

   sprintf(reg,"%s %s %s %s %s %s\n",user,data,hora,ip,url,smart);
   fputs(reg,fp_ou);

   fclose(fp_ou);

   return(0);

}
